| The Gaudi Framework v27r1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Namespace List
- Namespace Members

Namespaces | Classes | Typedefs | Functions
GaudiPython Namespace Reference

GaudiPython.h GaudiPython/GaudiPython.h. More...

## Namespaces
| Bindings
| GaudiAlgs
| GaudiHandles
| HistoUtils
| Persistency
| Pythonizations
| TupleUtils

## Classes
struct | _identity
| It is here due to 'missing'(?) std::identity. More...
class | AlgDecorator
class | CallbackStreamBuf
struct | Helper
class | HistoDecorator
| Simple decorator class to allow to reuse the functionality of GaudiHistos<TYPE> class in pythin. More...
struct | Interface
| Minor mofidication of original Pere's structure GaudiPython::Interface This helper class is nesessary to perform C++ castings from python. More...
struct | Interface< IInterface >
struct | Printer
struct | Printer< ContainedObject >
struct | Printer< DataObject >
class | PyAlg
| general class to embed the existing algorithm/base class into the python More...
class | PyAlgorithm
| Python Algorithm base class. More...
class | TupleAlgDecorator
| Simple class to perform the "decoration" of Tuples in Python/ROOT. More...
class | TupleDecorator
| Simple class which performs the decoration of the standard N-Tuple. More...
class | TupleToolDecorator
| Simple class to perform the "decoration" of Tuples in Python/ROOT. More...

## Typedefs
typedef std::vector< double > | Vector
| useful type definition for implicit loos More...
typedef Vector | Row
typedef std::vector< Row > | Matrix

## Functions
GAUDI_API StatusCode | call_python_method (PyObject *self, const char *method)
| call the python method More...
int GAUDI_API | call_python_method (PyObject *self, const char *method, char *buf)
| call a python method with a string as an argument More...

## Detailed Description

GaudiPython.h GaudiPython/GaudiPython.h.

Namespace for all classes interfacing Gaudi to Python.

The general namespace to hide all Gaudi-python related classes

Author
  Vanya BELYAEV Ivan..nosp@m.Bely.nosp@m.aev@l.nosp@m.app..nosp@m.in2p3.nosp@m..fr

Date
  2005-08-04

## Typedef Documentation

typedef std::vector<Row> GaudiPython::Matrix

Definition at line 21 of file Vector.h.

typedef Vector GaudiPython::Row

Definition at line 20 of file Vector.h.

typedef std::vector<double> GaudiPython::Vector

useful type definition for implicit loos

Definition at line 19 of file Vector.h.

## Function Documentation

int GaudiPython::call_python_method | ( | PyObject * | self,
|  | const char * | method,
|  | char * | buf
| ) |  |

call a python method with a string as an argument

Definition at line 14 of file CallbackStreamBuf.cpp.

15 {
16 if ( !self || !method ) { return 1 ; }
17 PyObject* r = PyObject_CallMethod(self, const_cast<char*>(method),
18 const_cast<char*>("s"), buf);
19 if ( !r ) {
20 std::string err("Unsuccessful call to bound Python method");
21 err += method;
22 PyErr_SetString( PyExc_TypeError , err.c_str() ) ;
23 PyErr_Print() ;
24 return 1 ;
25 }
26 Py_DECREF( r );
27 return 0 ;
28 }
std::string
STL class.

StatusCode GaudiPython::call_python_method | ( | PyObject * | self,
|  | const char * | method
| ) |  |

call the python method

Definition at line 29 of file Algorithm.cpp.

30 {
31 StatusCode sc = StatusCode::FAILURE;
32 // check arguments
33 if ( !self || !method ) { return StatusCode::FAILURE ; }
34
35 // call Python
36 PyObject* r = PyObject_CallMethod(self, chr(method), nullptr );
37
38 if ( !r ) { PyErr_Print() ; return sc ; } // RETURN
39
40 if ( PyInt_Check ( r ) )
41 { sc = PyInt_AS_LONG( r ) ; Py_DECREF( r ) ; return sc ; } // RETURN
42
43 // look for the method getCode with the signature:
44 // ' int getCode() '
45 PyObject* c = PyObject_CallMethod(r, chr("getCode"), nullptr);
46
47 if ( !c ) { PyErr_Print() ; }
48 else if ( PyLong_Check( c )) { sc = PyLong_AsLong( c ); }
49 else
50 {
51 std::string msg( " call_python_method unexpected type from '" );
52 msg += method ;
53 msg += "().getCode()' " ;
54 PyErr_SetString( PyExc_TypeError , msg.c_str() ) ;
55 PyErr_Print() ;
56 }
57 // release used objects
58 Py_XDECREF( c ) ;
59 Py_XDECREF( r ) ;
60 //
61 return sc;
62 }
GaudiMP.FdsRegistry.msg
tuple msg
Definition: FdsRegistry.py:8
gaudirun.c
tuple c
Definition: gaudirun.py:391
merge_files.sc
int sc
Definition: merge_files.py:167
std::string
STL class.
StatusCode::FAILURE
Definition: StatusCode.h:29
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:26